Merge of master-melb:xfs-cmds:29441a by kenmcd.
Test that fsync forces file size changes to disk.
--- /dev/null
+#! /bin/sh
+# FSQA Test No. 179
+#
+# Test for NULL files problem
+# test inode size is on disk after fsync
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2006 Silicon Graphics, Inc. All Rights Reserved.
+#-----------------------------------------------------------------------
+#
+# creator
+owner=lachlan@sgi.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ _cleanup_testdir
+}
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs xfs
+_supported_os Linux IRIX
+
+_setup_testdir
+_require_scratch
+_scratch_mkfs_xfs >/dev/null 2>&1
+_scratch_mount
+
+_check_files()
+{
+ # check file size and contents
+ i=1;
+ while [ $i -lt 1000 ]
+ do
+ file=$SCRATCH_MNT/$i
+ # if file does not exist, the create was not logged, skip it
+ if [ -e $file ]
+ then
+ # if file size is zero then fsync failed
+ if [ -s $file ]
+ then
+ # if file has non-zero size but no extents then it's contents will be NULLs, bad.
+ if xfs_bmap $file | grep 'no extents' > /dev/null
+ then
+ echo corrupt file $file - non-zero size but no extents
+ else
+ rm -f $file
+ fi
+ else
+ echo file $file has zero size - sync failed
+ fi
+ fi
+ i=`expr $i + 1`
+ done
+}
+
+# create files and fsync them
+i=1;
+while [ $i -lt 1000 ]
+do
+ file=$SCRATCH_MNT/$i
+ xfs_io -f -c "pwrite -b 32k -S 0xff 0 32k" -c "fsync" $file > /dev/null
+ i=`expr $i + 1`
+done
+
+# shutdown immediately after, then remount and test
+src/godown $SCRATCH_MNT
+umount $SCRATCH_MNT
+_scratch_mount
+_check_files
+
+status=0
+exit
--- /dev/null
+QA output created by 179
--- /dev/null
+#! /bin/sh
+# FSQA Test No. 179
+#
+# Test for NULL files problem
+# test inode size is on disk after sync
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2006 Silicon Graphics, Inc. All Rights Reserved.
+#-----------------------------------------------------------------------
+#
+# creator
+owner=lachlan@sgi.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ _cleanup_testdir
+}
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs xfs
+_supported_os Linux IRIX
+
+_setup_testdir
+_require_scratch
+_scratch_mkfs_xfs >/dev/null 2>&1
+_scratch_mount
+
+_check_files()
+{
+ # check file size and contents
+ i=1;
+ while [ $i -lt 1000 ]
+ do
+ file=$SCRATCH_MNT/$i
+ # if file does not exist, the create was not logged, skip it
+ if [ -e $file ]
+ then
+ # if file size is zero then fsync failed
+ if [ -s $file ]
+ then
+ # if file has non-zero size but no extents then it's contents will be NULLs, bad.
+ if xfs_bmap $file | grep 'no extents' > /dev/null
+ then
+ echo corrupt file $file - non-zero size but no extents
+ else
+ rm -f $file
+ fi
+ else
+ echo file $file has zero size - sync failed
+ fi
+ fi
+ i=`expr $i + 1`
+ done
+}
+
+# create files and sync them
+i=1;
+while [ $i -lt 1000 ]
+do
+ file=$SCRATCH_MNT/$i
+ xfs_io -f -c "pwrite -b 32k -S 0xff 0 32k" $file > /dev/null
+ i=`expr $i + 1`
+done
+
+# sync, then shutdown immediately after, then remount and test
+sync
+src/godown $SCRATCH_MNT
+umount $SCRATCH_MNT
+_scratch_mount
+_check_files
+
+status=0
+exit
--- /dev/null
+QA output created by 180
[ -z "$SCRATCH_DEV" ] && SCRATCH_DEV=/dev/sdb2
[ -z "$SCRATCH_LOGDEV" ] && SCRATCH_LOGDEV=/dev/sdb4
;;
+ melt)
+ MODULAR=1
+ TEST_DIR=/mnt/test
+ TEST_DEV=/dev/sdb1
+ SCRATCH_MNT=/mnt/scratch
+ SCRATCH_DEV=/dev/sdb2
+ ;;
*)
echo "Error: need to define parameters for host $HOST"
exit 1
174 rw filestreams auto
177 rw other auto
178 mkfs other auto
+179 metadata rw auto
+180 metadata rw auto